function [pop, nx, nz, nf, ninf] = strawberry_newpopulation (x0,a,b,npop,f,constrained)
  global strawberry_randomsolutionfn
  global strawberry_numberofprocessors
  nx = length(x0);
  fprintf(': %d decision variables\n', nx);
  nf = 0;
  ninf = 0;
  pop = [];                     % will be array of x+y values
  n = 0;
  ntries = 0;
  xcell{1} = x0;                        % start with initial guess

  for i=2:npop
    xcell{i} = strawberry_randomsolutionfn(a,b);
  end
  if strawberry_numberofprocessors > 1
    if constrained
      pop = parcellfun (strawberry_numberofprocessors, ...
                        @(x) [x; f(x); g(x)], xcell, 'VerboseLevel', 0 ...
                       );
    else
      pop = parcellfun (strawberry_numberofprocessors, ...
                        @(x) [x; f(x); 0], xcell, 'VerboseLevel', 0);
    end
  else                          %sequential operation
    x = xcell{1};
    if constrained
      [z g] = f(x);
    else
      z = f(x);
      g = 0;
    end
    y = [x; z; g];
    pop = zeros(length(y),npop);
    pop(:,1) = y;
    for i=2:npop
      x = xcell{i};
      nf = nf+1;
      if constrained
        [z g] = f(x);
      else
        z = f(x);
        g = 0;
      end
      pop(:,i) = [x; z; g];
    end
    %% pop = cellfun (@(x) [x; f(x); 0], xcell);
  end
  mtotal = size(pop,2);
  [n m] = size(pop);
  ninf = ninf + mtotal - m;
  %% each row consists of nx x values, nz y values and a feasibility
  %% indication
  nz = n-nx-1;
  fprintf(': %d objective function values\n', nz);
end
