function s = strawberry_select (N)
  %% select only from those solutions that have not been selected
  %% before, i.e. those with non-negative fitness values
  n = length(N);
  available = N >= 0;
  debugprint (4, 'select, available = ', available)
  na = sum(available);
  allpossibleindices = 1:n;
  indices = allpossibleindices(available);
  switch na
    case 0
      s = 0;                  %no solutions available.
    case 1
      s = indices(1);           %only one available so select it
    case 2
      if N(indices(1)) > N(indices(2))
        s = indices(1);
      else
        s = indices(2);
      end
    otherwise
      i = ceil(na * rand(2,1));
      i(i>na) = na;
      i(i<1) = 1;
      if N(indices(i(1))) > N(indices(i(2)))
        s = indices(i(1));
      else
        s = indices(i(2));
      end
  end
  if s>0
    debugprint(5, 'select: s N(s)', [s, N(s)])
  else
    debugprint(5, 'select: none available for selection')
  end
end
